<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <meta http-equiv="CONTENT-TYPE" content="text/html; charset=UTF-8">
  <title>glideinWMS - Glidein Frontend</title>
  <meta name="CREATED" content="0;0">
  <meta name="CHANGED" content="20100521;20081031;14115200">    
  <link rel="stylesheet" type="text/css" href="../common/glideinWMS.css" media="screen, projection" />
</head>

<body lang="en-US" dir="ltr">
    <h1>
        <a href="index.html">GlideinWMS</a>
	<span>The Glidein-based Workflow Management System</span>
    </h1>
    <ul class="breadcrumbs">
        <li><a href="../index.html">Home</a></li>
        <li><a href="./index.html">Glidein Frontend</a></li>
        <li>Configuration</li>
    </ul>
    <div class="clear" />
    <div class="leftmenu">
        <ul class="components">
	        <li> <a href="../index.html">Home</a></li>
	        <li> <a href="../download.html">Download</a></li>
	        <li> <a href="../frontend/index.html">Glidein Frontend</a></li>
            <li> <a href="../corral.html">Corral Frontend</a></li>
	        <li> <a href="../factory/index.html">WMS Factory</a></li>
	        <li> <a href="../components/index.html" >Components</a></li>
	        <li> <a href="../components/faq.html" class="last">FAQ</a></li>
        </ul>
        <div class="search">
            <div id="cse-search-form" style="width: 100%;">Loading</div>
            <script src="http://www.google.com/jsapi" type="text/javascript"></script>
            <script src="../common/glidein.js" type="text/javascript"></script>
            <script type="text/javascript">
            google.load('search', '1', {language : 'en', style : google.loader.themes.MINIMALIST});
            google.setOnLoadCallback(onLoad);
            </script>
        </div>
    </div>
    <div id="searchcontent"><h2>Search Results</h2><div id="cse"></div> </div>
<div class="content">
    <div class="heading">
    <img align="right" width="280px" border="0px"
        src="../images/simple_diagram.png" usemap="#rightimage">
    <map name="rightimage">
        <area shape="rect" coords="90,3,177,60" href="../frontend/index.html" />
        <area shape="rect" coords="5,88,118,146" href="../components/collector_install.html" />
        <area shape="rect" coords="134,88,275,146" href="../factory/index.html" />
        <area shape="rect" coords="189,3,274,60" target="_blank" href="../corral.html" />
    </map>

    <h2>Glidein Frontend</h2>
	<ul class="subcomponents">
	     <li> <a href="./index.html">Overview</a></li>
	     <li> <a href="./install.html">Install</a></li>
	     <li> Configuration</li>
	     <li> <a href="./design.html">Design</a></li>
         <li> <a href="./monitoring.html">Monitoring</a></li>
	     <li class="last"> <a href="./troubleshooting.html">Troubleshooting</a></li>
	</ul>
        <h3>Configuration</h3>
	</div>
<div class="jump">
<u>Jump to:</u>
<ol>
        <li><a href="#example">Example Configuration</a> </li>
        <li><a href="#management">Frontend Configuration</a> </li>
        <li><a href="#custom_code">Customizing the glidein Startup</a> </li>
        <li><a href="#multiple_proxy">Using multiple proxies</a> </li>
        <LI><A HREF="#run_daemon">Starting the Daemon</A> </li>
</ol>
</div>
<div class="related">
Related Information:
<ul>
<li> <a href="./install.html">Install</a></li>
<li> <a href="./troubleshooting.html">Troubleshooting</a></li>
</ul>
</div>
<div class="section">
<a name="example" />
<h2>Example Configuration</h2>

Below is an example frontend configuration xml file.
Click on any piece for a more detailed description.

<div class="config">
    <a href="#frontend">&lt;frontend advertise_delay="5" frontend_name="vofrontend-v2_4" loop_delay="60"&gt;</a><br/>
    <blockquote>
        <a href="#">&lt;downtimes /&gt;</a><br/>
        <a href="#match">&lt;match match_expr="True"&gt;</a><br/>
        <blockquote>
            <a href="#match">&lt;factory query_expr="True"&gt;</a><br/>
            <blockquote>
                <a href="#group_match_attr">&lt;match_attrs /&gt;</a><br/>
                <a href="#collector">&lt;collectors&gt;</a><br/>
                <blockquote>
                    <a href="#collector">&lt;collector DN="/DC=org/DC=doegrids/OU=Services/CN=factory-server.fnal.gov" comment="" factory_identity="factoryuser@factory-server.fnal.gov" my_identity="frontenduser@frontend-server.fnal.gov" node="factory-server.fnal.gov:8618" /&gt;</a><br/>
                </blockquote>
                <a href="#collector">&lt;/collectors&gt;</a><br/>
            </blockquote>
            <a href="#match">&lt;/factory&gt;</a><br/>
            <a href="#job_query">&lt;job comment="" query_expr="(JobUniverse==5)&amp;&amp;(GLIDEIN_Is_Monitor =!= TRUE)&amp;&amp;(JOB_Is_Monitor =!= TRUE)"&gt;</a><br/>
            <blockquote>
                <a href="#match">&lt;match_attrs /&gt;</a><br/>
                <a href="#schedd">&lt;schedds&gt;</a><br/>
                <blockquote>
                    <a href="#schedd">&lt;schedd DN="/DC=org/DC=doegrids/OU=Services/CN=userpool.fnal.gov" fullname="userpool.fnal.gov"&gt;</a><br/>
                    <a href="#schedd">&lt;schedd DN="/DC=org/DC=doegrids/OU=Services/CN=userpool.fnal.gov" fullname="schedd_jobs1@userpool.fnal.gov"&gt;</a><br/>
                    <a href="#schedd">&lt;schedd DN="/DC=org/DC=doegrids/OU=Services/CN=userpool.fnal.gov" fullname="schedd_jobs2@userpool.fnal.gov"&gt;</a><br/>
                </blockquote>
                <a href="#schedd">&lt;/schedds&gt;</a><br/>
            </blockquote>
            <a href="#job_query">&lt;/job&gt;</a><br/>
        </blockquote>
        <a href="#match">&lt;/match&gt;</a><br/>
        <br/>
        <a href="#monitor">&lt;monitor base_dir="/var/www/html/vofrontend/monitor" flot_dir="/opt/javascriptrrd-0.5.0/flot" javascriptRRD_dir="/opt/javascriptrrd-0.5.0" jquery_dir="/opt/javascriptrrd-0.5.0/flot"&gt;</a><br/><br/>
        <a href="#security">&lt;security classad_proxy="/etc/grid-security/vocert.pem" proxy_DN="/DC=org/DC=doegrids/OU=Services/CN=frontend-server.fnal.gov" proxy_selection_plugin="ProxyAll" security_name="frontenduser" sym_key="aes_256_cbc"&gt;</a><br/>
        <blockquote>
        <a href="#proxies">&lt;proxies&gt;</a><br/>
        <blockquote>
            <a href="#proxies">&lt;proxy absfname="/tmp/x509up_u" security_class="frontend"&gt;</a><br/>
        </blockquote>
        <a href="#proxies">&lt;/proxies&gt;</a><br/>
    </blockquote>
    <a href="#stage">&lt;stage base_dir="/var/www/html/vofrontend/stage" use_symlink="True" web_base url="http://frontend-server.fnal.gov:9000/vofrontend/stage"&gt;</a><br/>
    <a href="#work">&lt;work base_dir="/opt/vofrontend" base_log_dir="/opt/vofrontend/logs"&gt;</a><br/>
    <a href="#attrs">&lt;attrs&gt;</a><br/>
    <blockquote>
        <a href="#attr_client_rank">&lt;attr name="GLIDECLIENT_Rank" glidein_publish="False" job_publish="False " parameter="True" type="string" value="1"&gt;</a><br/>
        <a href="#attr_client_start">&lt;attr  name="GLIDECLIENT_Start" glidein_publish="False" job_publish="False" parameter="True" type="string" value="True"&gt;</a><br/>
        <a href="#attr_expose">&lt;attr  name="GLIDEIN_Expose_Grid_Env" glidein_publish="True" job_publish="True" parameter="False" type="string" value="True"&gt;</a><br/>
        <a href="#attr_glexec">&lt;attr name="GLIDEIN_Glexec_Use" glidein_publish="True" job_publish="True" parameter="False" type="string" value="OPTIONAL"&gt;</a><br/>
        <a href="#attr_match">&lt;attr name="USE_MATCH_AUTH" glidein_publish="False" job_publish="False" parameter="True" type="string" value="True"&gt;</a><br/>
    </blockquote>
    <a href="#attrs">&lt;/attrs&gt;</a><br/>
    <a href="#group">&lt;groups&gt;</a><br/>
    <blockquote>
        <a href="#group">&lt;group name="main" enabled="True"&gt;</a><br/>
        <blockquote>
            <a href="#group_config">&lt;config&gt;</a><br/>
            <blockquote>
                <a href="#group_config">&lt;idle_glideins_per_entry max="100" reserve="5"&gt;</a><br/>
                <a href="#group_config">&lt;idle_vms_per_entry curb="5" max="100"&gt;</a><br/>
                <a href="#group_config">&lt;running_glideins_per_entry max="10000" relative_to_queue="1.15"&gt;</a><br/>
            </blockquote>
            <a href="#group_config">&lt;/config&gt;</a><br/>
            <a href="#">&lt;downtimes /&gt;</a><br/>
            <a href="#group_match">&lt;match match_expr="True"&gt;</a><br/>
            <blockquote>
                <a href="#group_factory">&lt;factory query_expr="True"&gt;</a><br/>
                <blockquote>
                    <a href="#group_factory">&lt;match_attrs /&gt;</a><br/>
                    <a href="#group_factory">&lt;collectors /&gt;</a><br/>
                </blockquote>
                <a href="#group_factory">&lt;/factory&gt;</a><br/>
                <a href="#group_job">&lt;job query_expr="True"&gt;</a><br/>
                <blockquote>
                    <a href="#group_job">&lt;match_attrs /&gt;</a><br/>
                    <a href="#group_job">&lt;schedds /&gt;</a><br/>
                </blockquote>
                <a href="#group_job">&lt;/job&gt;</a><br/>
            </blockquote>
            <a href="#group_security_proxies">&lt;security&gt;</a><br/>
                <blockquote>
                    <a href="#group_security_proxies">&lt;proxies /&gt;</a><br/>
                </blockquote>
            <a href="#">&lt;/security&gt;</a><br/>
            <a href="#">&lt;attrs /&gt;</a><br/>
            <a href="#files">&lt;files /&gt;</a><br/>
        </blockquote>
        <a href="#">&lt;/group&gt;</a><br/>
    </blockquote>
    <a href="#">&lt;/groups&gt;</a><br/>
     
    <a href="#collectors">&lt;collectors&gt;</a><br/>
    <blockquote>
        <a href="#collectors">&lt;collector DN="/DC=org/DC=doegrids/OU=Services/CN=usercollector.fnal.gov" node="usercollector.fnal.gov" secondary="False"&gt;</a><br/>
    </blockquote>
    <a href="#collectors">&lt;/collectors&gt;</a><br/>
    <a href="#files">&lt;files /&gt;</a><br/>
    </blockquote>
    <a href="#">&lt;/frontend&gt;</a><br/>
</div>


</div>
<div class="section">

<H2 CLASS="western"><A NAME="management"></A>The Glidein Frontend
Configuration</H2>
<P>The Glidein Frontend configuration involves creating the configuration
directory and files and then creating the daemons. As in the Glidein
Factory set up, an XML file is converted into a configuration tree by
a configuration tool.</P>
<P>For the installer to create the Glidein Frontend instance from the
configuration directory and grid mapfile, the following objects can
be defined:</P>
<UL>

    <LI><P>
        <a name="frontend" />
        <div class="xml">
        &lt;frontend frontend_name=&quot;<I>your name</I>&quot;
        advertise_delay=&quot;<I>seconds</I>&quot;
        loop_delay=&quot;<I>nr</I>&quot; &gt;
	advertise_with_tcp=&quot;<I>True|False</I>&quot; 
	advertise_with_multiple=&quot;<I>True|False</I>&quot;&gt;
        </div>
    The frontend_name is a combination of the frontend
    and instance names specified during installation. It is used to
    create Glidein Frontend instance directory and files. The delay
    parameters define how active the Glidein Frontend should be. 
Finally, advertise_with_tcp defines if TCP should be use to advertise the ClassAds to the factory, and advertise_with_multiple can enable the condor_advertise -multiple option present in Condor 7.5.4 and up. 
    </P></li>
    <LI><P>
        <a name="collector" />
        <div class="xml">
        &lt;frontend&gt;&lt;match&gt;&lt;factory&gt;&lt;collectors&gt;&lt;collector
        my_identity=&quot;<I>joe@collector1.myorg.com</I>&quot; 
        node=&quot;<i>collector1.myorg.com</I>&quot;

        factory_identity=&quot;<I>gfactory@gfactory1.my.org</I>&quot;
        DN=&quot;<I>/DC=org/DC=doegrids/OU=Services/CN=collector/collectory1.my.org</I>&quot;/&gt;
        </div>
    This shows what WMS Collector the Glidein Frontend will map to. It is the
    mapped name for the identity of the classad. It also tells what
    should be the idetnity used by the frontend itself and the expected
    identity of the factory.  These attributes must be configured correctly,
    or else the factory will drop requests from the frontend, citing security
    concerns.
    </P></li>
    <LI><P>
        <a name="job_query" />
        <div class="xml">

        &lt;frontend&gt;&lt;match&gt;&lt;job 
        query_expr=&quot;<I>expression</I>&quot; &gt;
        </div>
    A <A HREF="http://www.cs.wisc.edu/condor/manual/v7.0/condor_q.html">
    Condor constraint</A> to be used with condor_q when looking for user 
    jobs.  (like 'JobUniverse=?=5', i.e. consider only Vanilla jobs). If you
    want to consider all user jobs, this can be set to TRUE. 
    </P></li>

    <LI><P>
        <a name="schedd" />
        <div class="xml">
        &lt;frontend&gt;&lt;match&gt;&lt;job&gt;&lt;schedds&gt;&lt;schedd fullname=&quot;<I>schedd name</I>&quot; /&gt;
        </div>
    When you provide the user pool collector to the installer, it will find
    all the available schedds. You can specify which schedds to monitor
    here for user jobs. The schedd fullname is the name under which
    schedd is registered with the user pool collector.&nbsp; 
    </P></li>

    <LI><P>
        <a name="monitor" />
        <div class="xml">
        &lt;frontend&gt;&lt;monitor 
        base_dir=&quot;<I>web_dir</I>&quot;
        flot_dir=&quot;<I>web_dir</I>&quot;
        javascriptRRD_dir=&quot;<I>web_dir</I>&quot;

        jquery_dir=&quot;<I>web_dir</I>&quot; /&gt;
        </div>
    The <STRONG>base_dir</STRONG> defines where the web
    monitoring is. The other entries point to where javascriptRRD, Flot
    and JQuery libraries are located. 
    </P></li>
    <LI><P>
        <a name="security" />
        <div class="xml">

        &lt;frontend&gt;&lt;security 
        proxy_DN=&quot;<I>/DC=org/DC=doegrids/OU=Service/CN=frontend/frontend1.my.org</I>&quot;
        classad_proxy=&quot;<I>proxy_dir</I>&quot;
        proxy_selection_plugin=&quot;<I>ProxyAll</I>&quot;
        security_name=&quot;<I>vofrontend1</I>&quot;&gt;

        </div>
    Grid proxy to use is located in the classad_proxy directory and you must
    specify the full path to the proxy. security_name signifies the name
    under which the frontend is registered with the factory. 
    </P></li>
    <LI><P>
        <a name="proxies" />
        <div class="xml">
        &lt;frontend&gt;&lt;security&gt;&lt;proxies&gt;&lt;proxy
        absfname=&quot;<I>proxy</I>&quot;
        security_class=&quot;<I>frontend</I>&quot;/&gt;

        </div>
    The location of the proxy the Glidein Frontend forwards to the factory for
    use in submitting glideins. You can have multiple proxy entries
    listed here and they are used by all groups.
    </P></li>
    <LI><P>
        <a name="stage" />
        <div class="xml">
        &lt;frontend&gt;&lt;stage
        base_dir=&quot;<I>web_dir</I>&quot;
        web_base_url=&quot;<I>URL</I>&quot; /&gt;

        </div>
    The location of the web server directories. It is
    the staging area where the files needed to run you job are located
    (i.e. condor). You may need to change this according to your
    requirements. 
    </P></li>
    <LI><P>
        <a name="work" />
        <div class="xml">
        &lt;frontend&gt;&lt;work
        base_dir=&quot;<I>directory</I>&quot; /&gt;
        </div>

        This defines the path to the Glidein Frontend directory. 
    </P></li>
        <LI><P>
                <div class="xml">
                &lt;frontend&gt;&lt;files&gt;&lt;file
                absfname=&quot;<I>filepath</I>&quot;
                relfname=&quot;<I>filename</I>&quot;

                executable=&quot;<I>boolean</I>&quot; /&gt;
                </div>
        The file parameters are used to specify the location
        of additional files. The grid mapfile location must be specified.
    This can be used to add custom scripts to the vo frontend.  
    See <a href="#custom_code">below</a> or  the page dedicated to 
    <a href="../factory/custom_scripts.html">writing custom scripts</a> for more
    information.
        </P></li>

    <LI><P>
        <a name="files" />
        <div class="xml">
        &lt;frontend&gt;&lt;attrs&gt;&lt;attr
        name=&quot;<I>attr_name</I>&quot;
        value=&quot;<I>value</I>&quot;
        parameter=&quot;True&quot;

        type=&quot;string&quot;
        glidein_publish=&quot;<I>boolean</I>&quot;
        job_publish=&quot;<I>boolean</I>&quot; &gt;
        </div>
    The following three attributes are required to be set
    in the frontend requests and/or published for jobs. Others can be
    specified as well. 
    </P>

    <UL>
        <LI><P>
        <a name="attrs" />
            <div class="xml">
            &lt;attr name=&quot;GLIDEIN_Collector&quot; &gt;
            </div>
        The contains the name of the pool collector, i.e.
        mymachine.mydomain.</P></li>
        <LI><P>

        <a name="attr_expose" />
            <div class="xml">
            &lt;attr name=&quot;GLIDEIN_Expose_Grid_Env&quot; &gt;
            </div>
        This determines if you want to expose the user to
        the grid environment.</P></li>
        <LI><P>
        <a name="attr_match" />
            <div class="xml">
            &lt;attr name=&quot;USE_MATCH_AUTH&quot; &gt;

            </div>
        This determines whether or not you want to use match
        authentication. You specify the match expression in a 
        group section of the config file.</P></li>
        <LI><P>
        <a name="attr_glexec" />
            <div class="xml">
            &lt;attr name=&quot;GLIDEIN_Glexec_Use&quot; &gt;
            </div>
        This determines whether or not you want to mandate
        the use of GLEXEC. Possible values are 
            NONE (do not use GLEXEC) or
            OPTIONAL (use GLEXEC if the site is configured with it) 
            or REQUIRED (Always use GLEXEC). 
        Mandating the use of GLEXEC also enforces the
        factory to submit jobs to sites that have GLEXEC configured.
        </P></li>
        <LI><P>
        <a name="attr_client_rank" />
            <div class="xml">
            &lt;attr name=&quot;GLIDECLIENT_Rank&quot; &gt;
            </div>
        This is a condor expression that allows the ranking and prioritization
        of jobs.  This attribute is propagated to condor_vars.lst.

        </P></li>
        <LI><P>
        <a name="attr_client_start" />
            <div class="xml">
            &lt;attr name=&quot;GLIDECLIENT_Start&quot; &gt;
            </div>
            This is a condor expression that determines whether a glidein job
            will start on a resource.  It is used for resource management by
            Condor.
        </P></li>
    </UL>
</UL>
    <P>Other attributes can be specified as well. They are used by the
    VO frontend matchmaking and job matchmaking. The format is similar
    to the attributes on the Factory config file. The table below
    describes the &lt;attrs ... &gt; tag in more detail. 
    </P>
    <table class="requirements">
        <TR class="head">
            <TD> <P><B>Attribute Name</B></P> </TD>

            <TD> <P><B>Attribute Description</B></P> </TD>
        </TR>
        <TR>
            <TD> <P><b>name</b></P> </TD>
            <TD> <P>Name of the attribute</P> </TD>

        </TR>
        <TR>
            <TD> <P><b>value</b></P> </TD>
            <TD> <P>Value of the attribute</P> </TD>
        </TR>
        <TR>

            <TD> <P><b>parameter</b></P> </TD>
            <TD> <P>Set to True if the attribute should 
 be passed as a parameter.  If set to False, the attribute will be put in the staging area to be accessed by the glidein startup scripts.  Always set this to True unless you know what you are doing.</P>
            </TD>
        </TR>
        <TR>
            <TD> <P><b>glidein_publish</b></P> </TD>

            <TD> <P>If set to True, the attribute will be available in the condor_startd's classad. Used only if parameter is True.</P>
            </TD>
        </TR>
        <TR>
            <TD> <P><b>job_publish</b></P> </TD>
            <TD> <P>If set to True, the attribute will be available in the user job's environment. Used only if parameter is True.</P>

            </TD>
        </TR>
        <TR>
            <TD> <P><b>comment</b></P> </TD>
            <TD> <P>You can specify description of the attribute here.</P>
            </TD>

        </TR>
        <TR>
            <TD> <P><b>type</b></P> </TD>
            <TD> <P>Type of the attribute. Supported types are 'int', 'string' and 'expr'. Type expr is equivalent to condor constant/expression in condor_vars.lst</P>
            </TD>
        </TR>

    </TABLE>
    <P>An example attribute would be:</P>
        <div class="xml" style="padding-left:30px;">
        &lt;attrs&gt;&lt;attr name=&quot;GLIDEIN_Collector&quot; value=&quot;mymachine.mydomain&quot; publish=&quot;True&quot; parameter=&quot;True&quot; const=&quot;True&quot; glidein_publish=&quot;True&quot; comment=”Just a test attribute”/&gt;

        </div>
<P>The following group parameters are used to configure multiple
frontends. If only one group is specified, they apply to all
frontends. The objects specified are used for creating and monitoring
glideins.  Groups are used to group users with similar requirements, such as proxies, criteria for matching job requirements with sites, and configuration of glideins.
</P>
<UL>
    <LI><P>
        <a name="group" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group
        name=&quot;<I>name</I>&quot;
        enabled=&quot;<I>boolean</I>&quot; &gt;

        </div>
    This specifies the name of the group and whether it is enabled. 
    </P></li>
    <LI><P>
        <a name="group_config" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;config&gt;
        </div>
    The parameters listed here define how many glideins to create and
    maintain, such as idle_glideins_per_entry 
    and running_glideins_per_entry. 
    </P></li>

    <LI><P>
        <a name="group_match" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;match
        match_expr=&quot;<I>expr</I>&quot; &gt;
        </div>
    A Python boolean expression is used to match glideins
    to jobs. The glidein and job dictionaries are used in the
    expression, i.e. glidein[&quot;attrs&quot;][&quot;GLIDEIN_Site&quot;]
    in job[&quot;DESIRED_Sites&quot;].split(&quot;,&quot;). If you want
    to match all, just specify True. 
    </P></li>

    <LI><P>
        <a name="group_factory" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group&gt;&lt;match&gt;&lt;factory query_expr=&quot;<I>expr</I>&quot; &gt;
        </div>
        A Python expression that specifies a factory constraint. 
    </P></li>

    <LI><P>
        <a name="group_match_attr" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group&gt;&lt;match&gt;&lt;factory&gt;&lt;match attrs&gt;&lt;match attr name=&quot;<I>name</I>&quot; &gt;
        </div>

    A list of glidein factory attributes used in the
    factory match expression. 
    </P></li>
    <LI><P>
        <a name="group_job" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group&gt;&lt;match&gt;&lt;job
        query_expr=&quot;<I>expr</I>&quot; &gt;
        </div>

        A Python expression that specifies a job constraint. 
    </P></li>
    <LI><P>
        <a name="group_job_match" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group&gt;&lt;match&gt;&lt;job&gt;&lt;match attrs&gt;&lt;match attr name=&quot;<I>name</I>&quot; &gt;

        </div>
        A list of job attributes used in the factory match expression. 
    </P></li>
    <LI><P>
        <a name="group_security_proxies" />
        <div class="xml">
        &lt;frontend&gt;&lt;groups&gt;&lt;group&gt;&lt;security&gt;&lt;proxies&gt;&lt;proxy
        absfname=&quot;<I>proxy</I>&quot;
        security_class=&quot;<I>classname</I>&quot; &gt;

        </div>
        Group-specific proxies for submitting glideins can be defined that will be passed to the factory in addition to any globally defined proxies.
    </P></li>
    <LI><P>
        <a name="collectors" />
        <div class="xml">
        &lt;collectors&gt;&lt;collector DN="<i>certificate DN</i>" node="<i>User Pool Collector</i>" secondary="<i>True/False</i>" &gt;
        </div>
        List of user pool collector(s) where condor_startd started by glideins
should report to as a available resource.  This is where the user jobs will be matched with glidein resources.
    </li>
</UL>
</div>
<div class="section">
<h3><A NAME="custom_code"></A>Adding Custom Code/Scripts to Glidein Frontend Glideins</H3>
    You can add custom scripts to glideins created for this Glidein Frontend by adding scripts and files to the configuration in the files section: 
        <div class="xml">
        &lt;glidein&gt;<br>
        &nbsp;[&lt;groups&gt;&lt;group&gt;]<br>

        &nbsp;&lt;files&gt;<br>
        &nbsp;&nbsp;&lt;file absfname="<i>script name</i>" 
        executable="True"
        comment="<i>comment</i>"/&gt;

        </div>
    <p>The script will be copied to the
    Web-accessible area and added to the glidein's file_list, 
    and when a glidein starts, the&nbsp;glidein
    startup script will pull it and execute it. If any parameters are
    needed, they can be specified using <b>&lt;attr /&gt;</b>.
    </p>

    <p>For more detailed information,
    see the page dedicated to 
    <a href="../factory/custom_scripts.html">writing custom scripts</a>.</p>
<p>
    You can also create wrapper scripts or tar-balls of files, see
    <a href="../factory/design_entry.html#custom_code">the factory entry page</a> for
    syntax.  (Use groups/group tags instead of the factory's entry tag).
</p>
</div>
<div class="section">
    <H2 CLASS="western"><A NAME="match_example"></A>
        Match and Match Attributes
    </h2>
<p>
    Several sections in the configuration allow a match expression.
    This allows a white list by the frontend by where the glideins
    should be submitted.  This can allow you to give a Condor expression
    to specify where jobs can run.  This can allow user jobs to specify
    which glidein_sites can run their jobs.  See the example below.
    Note that matches can be scoped to either global scope 
    (&lt;frontend&gt;&lt;match&gt;) or to a group specific scope.
</p>   
        <div class="xml">
         &lt;match match_expr='glidein["attrs"]["GLIDEIN_Site"] in
job["DESIRED_Sites"].split(",")'&gt;<br/>
            &lt;factory query_expr="(GLIDEIN_Site=!=UNDEFINED)"&gt;<br/>
               &lt;match_attrs&gt;
                  &lt;match_attr name="GLIDEIN_Site" type="string"/&gt;
               &lt;/match_attrs&gt;<br/>
               &lt;collectors&gt;
               &lt;/collectors&gt;<br/>
            &lt;/factory&gt;<br/>
            &lt;job query_expr="(DESIRED_Sites=!=UNDEFINED)"&gt;<br/>
               &lt;match_attrs&gt;
                  &lt;match_attr name="DESIRED_Sites" type="string"/&gt;
               &lt;/match_attrs&gt;<br/>
               &lt;schedds&gt;
               &lt;/schedds&gt;<br/>
            &lt;/job&gt;<br/>
         &lt;/match&gt;<br/>
        </div>
 

</p>
</div>
<div class="section">
<a name="multiple_proxy" />
<h2>Using Multiple Proxies</h2>

<p>
<b>
    Why would you want to use a pool of pilot proxies 
    instead of a single one?
</b>
</p>

<p>
If your VO maps to a single group account at the remote grid sites, you
wouldn't.  A pool of pilot proxies (try saying that 5 times fast) does
not gain you anything.  
If your VO maps to a pool of accounts at remote grid sites, you should
consider using a pool of proxies equivalent to the number of users you
have.  Why?</p>

<p>
Consider the following scenario: Alice, Bob, and Charlie are all in the
FUNGUS experiment and form a VO.  They are using glideinWMS.  Alice
sends 1000 jobs to FNAL via their glideinWMS using a single pilot proxy.
   The pilots map to ther userid fungus01 at FNAL, and in accordance with
the batch system's fairshare policies, the job priority for user
fungus01 is decreased significantly.
</p>
<p>
Bob comes along and submits 1000 jobs via glideinWMS, while Charlie
submits 1000 jobs under his own proxy and not using glideinWMS.  The
glideinWMS pilots launch for Bob, and map to fungus01. Charlie launches
his own jobs that get mapped to fungus73.  Relative to fungus02,
fungus01 priority is terrible, and Bob's jobs sit around waiting for
Charlie -- even though Bob didn't occupy the FNAL resources, Alice did!
</p>
<p>
The solution: have a pool of pilot proxies.  We then spread the
fairshare penalty amongst fungus01, fungus02, and fungus03, and Bob now
can compete on a more equal footing with Charlie.
</p>
<p>
<b>Using multiple proxies</b>
</p>
<p>
Proxies can be specified in the 
<tt>&lt;security&gt;&lt;proxies&gt;&lt;proxy&gt;</tt> tags.  Multiple proxy tags can be entered, one for each proxy file.  These can found in the security section at the top of the xml, in which case, the proxies are shared for all securitty groups.  They can also be found within <tt>&lt;group&gt;</tt> tags, in which case they are used only by that security group.
</p>
<p>
One example follows:
<div class="config">
<blockquote>
         &lt;security&gt;<br/>
<blockquote>
            &lt;proxies&gt;<br/>
<blockquote>
               &lt;proxy absfname="/home/frontend/.globus/x509_pilot05_cms_prio.proxy" security_class="cmsprio"/&gt;<br/>
               &lt;proxy absfname="/home/frontend/.globus/x509_pilot06_cms_prio.proxy" security_class="cmsprio"/&gt;<br/>
               &lt;proxy absfname="/home/frontend/.globus/x509_pilot07_cms_prio.proxy" security_class="cmsprio"/&gt;<br/>
               &lt;proxy absfname="/home/frontend/.globus/x509_pilot08_cms_prio.proxy" security_class="cmsprio"/&gt;<br/>
               &lt;proxy absfname="/home/frontend/.globus/x509_pilot09_cms_prio.proxy" security_class="cmsprio"/&gt;<br/>
</blockquote>
            &lt;proxies&gt;<br/>
</blockquote>
         &lt;security&gt;<br/>
</blockquote>
</div>
</p>
</div>
<div class="section">
<H2 CLASS="western"><A NAME="run_daemon"></A>Starting a Glidein Frontend
Daemon</H2>
<P>Once you have the desired configuration file, move to the VO
frontend directory&nbsp; and launch the command:</P>

    <blockquote>./frontend_startup start</blockquote>
<P>
All the activity messages will go into 
</P>
    <BLOCKQUOTE>group_*/log/frontend_info.&lt;date&gt;.log</BLOCKQUOTE>
<P>while the warnings go into </P>
    <BLOCKQUOTE>group_*/log/frontend_err.&lt;date&gt;.log</BLOCKQUOTE>

<P><A NAME="ref"></A>
    The frontend logs are deleted after a week.
</P>
</div>

<div class="footer">
Banner image by
<a href="http://www.flickr.com/people/leafwarbler/">Madhusudan Katti</a>
used under Creative Commons license.<br>
Original Home URL: <a href="http://www.uscms.org/SoftwareComputing/Grid/WMS/glid%0AeinWMS">http://www.uscms.org/SoftwareComputing/Grid/WMS/glideinWMS</a>.
glideinWMS email support: glideinwms-support at fnal.gov
</div>

</div>
</body>
</html>
